import os
import time
# pip3 install pynput
# pip install pynput
from pynput import keyboard
from pynput.keyboard import Key

SCENE_WIDTH = 12
SCENE_HEIGHT = 15

is_game_running = True
pos_rocket = [0, 0] # x, y

# main game loop
while is_game_running:
    cmd_clear = 'clear' # 'cls' for windows
    os.system(cmd_clear)

    scene = []
    for i in range(SCENE_HEIGHT): # 0...14
        columns = []
        for j in range(SCENE_WIDTH):
             columns.append('⬛️')
        scene.append(columns)

    x = pos_rocket[0]
    y = pos_rocket[1]
    scene[y][x] = '🚀'
    # Windows Key + .
    # Mac contrl + cmd + space

    scene_lines = []
    for line in scene:
        str_line = ''.join(line)
        scene_lines.append(str_line)
    str_scene = '\n'.join(scene_lines)
    print('')
    print(str_scene)

    delay = 0.5 # seconds
    timestamp = time.time()

    #events = keyboard.Events()
    with keyboard.Events() as events:
        key = events.get(delay)

        if key is not None: # key != null
            key_code = key.key
            if key_code == Key.left:
                # pos_rocket[0] = pos_rocket[0] - 1
                x -= 1
            elif key_code == Key.right: # else if
                x += 1
            elif key_code == Key.up:
                y -= 1
            elif key_code == Key.down: # else if
                y += 1

            x = max(0, min(x, SCENE_WIDTH-1))
            y = max(0, min(y, SCENE_HEIGHT-1))
            pos_rocket = [x, y]


    delta_delay = delay - (time.time() - timestamp)
    # if (delta_delay > 0 and delta_delay < 1000) or (delay > 100)
    if delta_delay > 0:
        time.sleep(delta_delay)

    # Object Oriented Programming (Unified Modelling Language)
    # Design patterns - Observable pattern